#property version   "1.00"
#include "miniNeuralNet.mqh";
input int display_size=300;//the size of the sides of the display
input bool reset_stats_after_batch=true;//reset stats after batch
input double base_learning_rate=0.001;//base learning rate 
//sample collector 
  //one sample has x bars values and the range min max 
    class ae_sample{
           public:
    double min,max,range;
    double bars[];
           ae_sample(void){reset();}
          ~ae_sample(void){reset();}
      void reset(){
           ArrayFree(bars);
           min=INT_MAX;
           max=INT_MIN;
           range=0.0;
           }
      void fill(int oldest_bar,int size){
           //get a windows data essentially
             //we'll use iseries here - make sure your chart is properly loaded 
               ArrayResize(bars,size,0);
               ArrayFill(bars,0,size,0.0);
               int co=-1;
               for(int i=oldest_bar;i>oldest_bar-size;i--){
                  co++;
                  if(iHigh(_Symbol,_Period,i)>max){max=iHigh(_Symbol,_Period,i);}
                  if(iLow(_Symbol,_Period,i)<min){min=iLow(_Symbol,_Period,i);}
                  bars[co]=iClose(_Symbol,_Period,i)-iOpen(_Symbol,_Period,i);
                  }
               //range 
                 range=max-min;
               //divisions
                 for(int i=0;i<size;i++){
                    bars[i]/=range;//-1.0 to 1.0
                    //turn to 0.0 to 1.0 because we have sigmoid and it wont be able to match outputs to inputs ever
                    bars[i]=(bars[i]+1.0)/2.0;
                    }
               //nice
           }
    };
    
    struct ae_sample_collection{
    ae_sample samples[];
              ae_sample_collection(void){reset();}
             ~ae_sample_collection(void){reset();}
         void reset(){
              ArrayFree(samples);
              }
         void add_sample(int oldest_bar,int window_size){
              int ns=ArraySize(samples)+1;
              ArrayResize(samples,ns,0);
              samples[ns-1].fill(oldest_bar,window_size);
              }
          int fill(int window_size){
              //get the bars of the chart 
                int barz=iBars(_Symbol,_Period);
                if(barz>TerminalInfoInteger(TERMINAL_MAXBARS)){barz=TerminalInfoInteger(TERMINAL_MAXBARS);}
                //we kinda want more than a 1000 samples 
                //let's create a sliding window so 19 of the 20 ... wait
                //window_size-1 of the bars will be the same across samples , this will create some interesting uses
                  int samples_possible=barz-window_size;
                  if(samples_possible>1000){
                  //okay so from the oldest bar possible to the recent bar possible 
                    int co=-1;
                    ArrayResize(samples,samples_possible,0);
                    for(int i=barz-1;i>=(1+window_size);i--){
                       Comment("Filling "+i);
                       co++;
                       samples[co].fill(i,window_size);
                       //add_sample(i,window_size);
                       }
                    ArrayResize(samples,co+1,0);
                  } 
              return(ArraySize(samples));
              }
    };
    
    ae_sample_collection COLLECTION;
snn_net net;
#define SYSTEM_TAG "AE_"
bool Loaded=false;
bool SystemBusy=false;
bool Train=false;
bool Animating=false;
uint display[];
int middleNodes=2;
double animationNodeValues[],animationNodeSteps[];
int OnInit()
  {
//---
  COLLECTION.reset();
  net.reset();
  Loaded=false;//this indicates we have loaded samples
  Train=false;
  Animating=false;
  ObjectsDeleteAll(ChartID(),SYSTEM_TAG);
  EventSetMillisecondTimer(544);
  ResourceFree("::DISPLAY");
//---
   return(INIT_SUCCEEDED);
  }
  
void OnTimer(){
  if(!Loaded){//if we have not loaded samples
  EventKillTimer();
  if(COLLECTION.fill(20)>=1000){//setup 
  Comment("Samples created ");
  //--------------------------------------
    //we will setup the network here 
    
    //input layer (20 nodes)
      net.add_layer().setup(20);//simple setup since input
    //layer 2 (3 nodes connects to input)
      net.add_layer().setup(3,20);
    //layer 3 (2 nodes connects to layer 2)
      net.add_layer().setup(2,3);
      middleNodes=2;
    //layer 4 (3 nodes connects to layer 3)
      net.add_layer().setup(3,2);
    //output layer 5 
      net.add_layer().setup(20,3);
    //oof
    
    //setup the animation stuffs
      ArrayResize(animationNodeSteps,middleNodes,0);
      ArrayFill(animationNodeSteps,0,middleNodes,0.005);
      ArrayResize(animationNodeValues,middleNodes,0);
      ArrayFill(animationNodeValues,0,middleNodes,0.00);
      
      
  //--------------------------------------
  //create deck 
    //input for nodes 
      ObjectCreate(ChartID(),SYSTEM_TAG+"_PAUSE",OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_PAUSE",OBJPROP_XSIZE,150);
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_PAUSE",OBJPROP_YSIZE,20);
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_PAUSE",OBJPROP_XDISTANCE,10);
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_PAUSE",OBJPROP_YDISTANCE,30);
      ObjectSetString(ChartID(),SYSTEM_TAG+"_PAUSE",OBJPROP_TEXT,"PAUSE");
    //animator
      ObjectCreate(ChartID(),SYSTEM_TAG+"_ANIMATE",OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_ANIMATE",OBJPROP_XSIZE,150);
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_ANIMATE",OBJPROP_YSIZE,20);
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_ANIMATE",OBJPROP_XDISTANCE,160);
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_ANIMATE",OBJPROP_YDISTANCE,30);
      ObjectSetString(ChartID(),SYSTEM_TAG+"_ANIMATE",OBJPROP_TEXT,"PAUSE+ANIMATE");      
      int py=50;
      for(int i=0;i<middleNodes;i++){
      string name=SYSTEM_TAG+"_NODE"+IntegerToString(i);
      ObjectCreate(ChartID(),name,OBJ_EDIT,0,0,0);
      ObjectSetInteger(ChartID(),name,OBJPROP_XSIZE,150);
      ObjectSetInteger(ChartID(),name,OBJPROP_YSIZE,20);
      ObjectSetInteger(ChartID(),name,OBJPROP_XDISTANCE,10);
      ObjectSetInteger(ChartID(),name,OBJPROP_YDISTANCE,py);
      ObjectSetInteger(ChartID(),name,OBJPROP_BGCOLOR,clrDarkKhaki);
      ObjectSetInteger(ChartID(),name,OBJPROP_BORDER_COLOR,clrGold);
      ObjectSetInteger(ChartID(),name,OBJPROP_COLOR,clrYellow);
      ObjectSetString(ChartID(),name,OBJPROP_TEXT,"0.0");
      ObjectSetInteger(ChartID(),name,OBJPROP_TIMEFRAMES,OBJ_NO_PERIODS);
      py+=20;
      }
      string name=SYSTEM_TAG+"_DISPLAY";
      ObjectCreate(ChartID(),name,OBJ_BITMAP_LABEL,0,0,0);
      ObjectSetInteger(ChartID(),name,OBJPROP_XSIZE,display_size);
      ObjectSetInteger(ChartID(),name,OBJPROP_YSIZE,display_size);
      ObjectSetInteger(ChartID(),name,OBJPROP_XDISTANCE,10);
      ObjectSetInteger(ChartID(),name,OBJPROP_YDISTANCE,py);
      ObjectSetString(ChartID(),name,OBJPROP_BMPFILE,"::DISPLAY");
      ObjectSetInteger(ChartID(),name,OBJPROP_TIMEFRAMES,OBJ_NO_PERIODS);
      ChartRedraw();
  //start timer again 
    ArrayResize(display,display_size*display_size,0);   
    EventSetMillisecondTimer(44);
    Loaded=true;
    Train=true;
  }else{
  Alert("Too little samples");
  ExpertRemove();
  }
  }
  else{
  
  if(!SystemBusy&&Train){
  SystemBusy=true;
  
  //train a batch
    //we will train a random order amount of samples 
    int ix=0;
    for(int i=0;i<ArraySize(COLLECTION.samples);i++)
     {
     //first create xor inputs 0 or 1 and the expected result 
       ix+=MathRand();
       while(ix>=ArraySize(COLLECTION.samples)){ix-=ArraySize(COLLECTION.samples);}
     //lets pass the features through the network
       net.feed_forward(COLLECTION.samples[ix].bars);//bars are the features
     //and lets calculate the loss 
       net.calculate_loss(COLLECTION.samples[ix].bars);//bars are also the results   
     //and lets backpropagate the error (we are not adjusting -learning- anything yet)
       net.back_propagation();  
     } 
     //"learn"
     double max_loss=net.get_max_loss_per_sample();
     double cur_loss=net.get_current_loss_per_sample();
     double a=(cur_loss/max_loss)*base_learning_rate;
     net.adjust(a);
     if(reset_stats_after_batch){net.reset_loss();} 
     string comm="Loss ("+cur_loss+")/("+max_loss+")";
     Comment(comm);     
  
  SystemBusy=false;
  }
  else if(!SystemBusy&&Animating){
  SystemBusy=true;
  
  for(int i=0;i<ArraySize(animationNodeValues);i++){
     animationNodeValues[i]+=animationNodeSteps[i];
     if(animationNodeValues[i]>1.0){animationNodeValues[i]=0.0;}
     if(animationNodeValues[i]<0.0){animationNodeValues[i]=1.0;}
     ObjectSetString(ChartID(),SYSTEM_TAG+"_NODE"+IntegerToString(i),OBJPROP_TEXT,DoubleToString(animationNodeValues[i],3));   
     }
  calculate_fake_chart(true);
  ChartRedraw();
  
  SystemBusy=false;
  }
  
  }
  }
  
void OnChartEvent(const int id,const long& lparam,const double& dparam,const string& sparam)
  {
  if(Loaded&&id==CHARTEVENT_OBJECT_CLICK){
    if(sparam==SYSTEM_TAG+"_PAUSE"&&Train){
      ObjectSetString(ChartID(),SYSTEM_TAG+"_PAUSE",OBJPROP_TEXT,"Continue");
      for(int i=0;i<middleNodes;i++){
         ObjectSetInteger(ChartID(),SYSTEM_TAG+"_NODE"+IntegerToString(i),OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);    
         }
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_DISPLAY",OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
      Train=false;
      calculate_fake_chart(false);
      ChartRedraw();
      }else if(sparam==SYSTEM_TAG+"_PAUSE"&&!Train){
      ObjectSetString(ChartID(),SYSTEM_TAG+"_PAUSE",OBJPROP_TEXT,"Pause");
      for(int i=0;i<middleNodes;i++){
         ObjectSetInteger(ChartID(),SYSTEM_TAG+"_NODE"+IntegerToString(i),OBJPROP_TIMEFRAMES,OBJ_NO_PERIODS);    
         }
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_DISPLAY",OBJPROP_TIMEFRAMES,OBJ_NO_PERIODS);
      Train=true;      
      }else if(sparam==SYSTEM_TAG+"_ANIMATE"&&Train){
      ObjectSetString(ChartID(),SYSTEM_TAG+"_PAUSE",OBJPROP_TEXT,"Continue");
      for(int i=0;i<middleNodes;i++){
         ObjectSetInteger(ChartID(),SYSTEM_TAG+"_NODE"+IntegerToString(i),OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);    
         animationNodeValues[i]=(double)StringToDouble(ObjectGetString(ChartID(),SYSTEM_TAG+"_NODE"+IntegerToString(i),OBJPROP_TEXT));
         Print("animation value "+i+" is "+animationNodeValues[i]);
         }
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_DISPLAY",OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
      ObjectSetString(ChartID(),SYSTEM_TAG+"_ANIMATE",OBJPROP_TEXT,"STOP ANIMATION");
      Train=false;
      Animating=true;
      ChartRedraw();
      }else if(sparam==SYSTEM_TAG+"_ANIMATE"&&!Train){
      ObjectSetString(ChartID(),SYSTEM_TAG+"_PAUSE",OBJPROP_TEXT,"Pause");
      for(int i=0;i<middleNodes;i++){
         ObjectSetInteger(ChartID(),SYSTEM_TAG+"_NODE"+IntegerToString(i),OBJPROP_TIMEFRAMES,OBJ_NO_PERIODS);    
         }
      ObjectSetInteger(ChartID(),SYSTEM_TAG+"_DISPLAY",OBJPROP_TIMEFRAMES,OBJ_NO_PERIODS);
      ObjectSetString(ChartID(),SYSTEM_TAG+"_ANIMATE",OBJPROP_TEXT,"PAUSE+ANIMATE");
      Train=true;      
      Animating=false;
      }
    }
  else if(Loaded&&id==CHARTEVENT_OBJECT_ENDEDIT){
    //find which node 
      if(StringFind(sparam,SYSTEM_TAG+"_NODE",0)!=-1){
        calculate_fake_chart(false);
        }
    }
  }
void calculate_fake_chart(bool for_animation){
        for(int i=0;i<middleNodes;i++){
           if(!for_animation){
           //get the value 
             double v=(double)StringToDouble(ObjectGetString(ChartID(),SYSTEM_TAG+"_NODE"+IntegerToString(i),OBJPROP_TEXT));
           //restrict it 
             if(v<0.0){v=0.0;}else if(v>1.0){v=1.0;}
           //pass it in the middle layer as output 
             net.layers[2].nodes[i].output=v;
             }else{
             net.layers[2].nodes[i].output=animationNodeValues[i];
             }
           }
        //and do a partial feed forward 
          net.partial_feed_forward(3);
        //fill fake bars 
          double fake_bars[];
          ArrayResize(fake_bars,20,0);
          for(int i=0;i<20;i++){fake_bars[i]=net.get_output(i);}
          //awesome but wait , these bars are 0.0 to 1.0 we must turn them to -1.0 to 1.0
          for(int i=0;i<20;i++){fake_bars[i]=(fake_bars[i]*2.0)-1.0;}
          create_fake_chart(fake_bars,display,display_size,clrBlack,clrGreen,clrCrimson);
          //create resource 
            if(ResourceCreate("DISPLAY",display,display_size,display_size,0,0,display_size,COLOR_FORMAT_ARGB_NORMALIZE)){
              ChartRedraw();
              }
}
void create_fake_chart(double &fake_bars[],//we receive the %'s here 
                       uint &pixels[],//the pixels where we draw 
                       int side_size,//the size of the sides of the output pixels
                       color bgColor,//background color
                       color upColor,//up fake bar color
                       color dwColor//down fake bar color
                       ){
//erase 
  ArrayFill(pixels,0,ArraySize(pixels),ColorToARGB(bgColor,255));
  /*
  this needs to be visible above all so we have x amount of bars 
  x+1 amount of gaps on the horizontal axis 
  each gap is half the fake bar so we have x+(x+1)/2 steps 
  tfb=total_fake_bars
  about x axis : 
      gap_size=bar_size/2;
      total_x=gap_size*(tfb+1)+bar_size*tfb;
      total_x=(bar_size/2)*(tfb+1)+bar_size*tfb;
      total_x=(bar_size)*[((tfb+1)/2)+tfb];
      bar_size=total_x/[((tfb+1)/2)+tfb];
  */
  double tfb=((double)ArraySize(fake_bars));
  double bar_size=((double)side_size)/(((tfb+1.0)/2.0)+tfb);
  double gap_size=bar_size/2.0;
  //neat
  //starting x
  double start_x=gap_size;
  //emulate 
  double emu_max=1.0,emu_min=1.0;
  //okay first price """"""was"""""" 1.0
    double price_now=1.0;
    //then we run in the fake bars which are supposed to be in sequence ....
    //that means we will add to one price point with each bar...
    //this won't like opening gaps
    double fake_bars_open_price[],fake_bars_close_price[];
    ArrayResize(fake_bars_open_price,ArraySize(fake_bars),0);
    ArrayResize(fake_bars_close_price,ArraySize(fake_bars),0);
    for(int i=0;i<ArraySize(fake_bars);i++){
       //open price is price now 
         fake_bars_open_price[i]=price_now;
         //price shifts
         price_now+=fake_bars[i];
       //close price is price now 
         fake_bars_close_price[i]=price_now;
       if(price_now>emu_max){emu_max=price_now;}
       if(price_now<emu_min){emu_min=price_now;}
       }
    //okay 
    double range=emu_max-emu_min;
    for(int i=0;i<ArraySize(fake_bars);i++){
      fake_bars_open_price[i]=(fake_bars_open_price[i]-emu_min)/range;
      fake_bars_close_price[i]=(fake_bars_close_price[i]-emu_min)/range;
      }
    //ready
      //prepare colors 
        uint upc=ColorToARGB(upColor,255);
        uint doc=ColorToARGB(dwColor,255);
    for(int i=0;i<ArraySize(fake_bars)-1;i++){
      //--open price
      //find y 
        double y_open=side_size-fake_bars_open_price[i]*((double)side_size);
        double y_close=side_size-fake_bars_close_price[i]*((double)side_size);
        uint colorused=upc;
        if(fake_bars_open_price[i]>fake_bars_close_price[i]){colorused=doc;}
      //aaand draw it 
        int x1=(int)start_x;
        int x2=(int)(start_x+bar_size);
        int y1=(int)MathMin(y_open,y_close);
        int y2=(int)MathMax(y_open,y_close);
        ResourceFillRectangle(x1,y1,x2,y2,colorused,pixels,side_size,side_size);
        start_x+=bar_size+gap_size;
      }
}

void ResourceFillRectangle(int x1,int y1,int x2,int y2,const uint clr,uint &m_pixels[],int m_width,int m_height)
  {
   int tmp;
//--- sort vertexes
   if(x2<x1)
     {
      tmp=x1;
      x1 =x2;
      x2 =tmp;
     }
   if(y2<y1)
     {
      tmp=y1;
      y1 =y2;
      y2 =tmp;
     }
//--- out of screen boundaries
   if(x2<0 || y2<0 || x1>=m_width || y1>=m_height)
      return;
//--- stay withing screen boundaries
   if(x1<0)
      x1=0;
   if(y1<0)
      y1=0;
   if(x2>=m_width)
      x2=m_width -1;
   if(y2>=m_height)
      y2=m_height-1;
   int len=(x2-x1)+1;
//--- set pixels
   for(; y1<=y2; y1++)
      ArrayFill(m_pixels,y1*m_width+x1,len,clr);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  COLLECTION.reset();
  net.reset();
  ObjectsDeleteAll(ChartID(),SYSTEM_TAG);   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
